VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsProcessCpuUsage"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------------------------------------------------------------------
' Module    : clsProcessCpuUsage
' DateTime  : 30/04/2007 23:21
' Author    : Vb System Library
' Purpose   : Rcuprer le pourcentage d'utilisation du processeur par un processus
' Copyright : (C) 2007 L'quipe Vb System Library
'              See "modPresentation" for more information
'---------------------------------------------------------------------------------------
' Librairie de fonctions permettant d'agir simplement et rapidement sur le systme.
' Copyright (C) 2007 - L'quipe Vb System Library
' This library is free software; you can redistribute it and/or
' modify it under the terms of the GNU Lesser General Public
' License as published by the Free Software Foundation; either
' version 2.1 of the License, or (at your option) any later version.
' This library is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
' Lesser General Public License for more details.
' You should have received a copy of the GNU Lesser General Public
' License along with this library; if not, write to the Free Software
' Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
'---------------------------------------------------------------------------------------


' Utilisation de la classe :
' Dim CpuUsage As New clsProcessCpuUsage
'   On indique le ProcessId du processus que l'on veut
' CpuUsage.SetPid = PID
'   Et puis on peut recuperer l'utilisation cpu quand on veut:
' CpuUsage.GetCpuUsage


Option Explicit

Private bRet                As Boolean

Private ftKernel            As FILETIME
Private ftUser              As FILETIME
Private ftKernelStart       As FILETIME
Private ftUserStart         As FILETIME

Private ProcessID           As Long
Private ProcessorCount      As Long

Private curStart            As Currency
Private curEnd              As Currency
Private curFreq             As Currency


'---------------------------------------------------------------------------------------
' Procedure : SetPid
' DateTime  : 30/03/2007 18:24
' Author    : Vb System Library
' Purpose   : Dfinit le processus  surveiller
' Params    : PID : ID du processus cible
'---------------------------------------------------------------------------------------
Public Function SetPid(ByVal PID As Long)
    
    ProcessID = PID
    InitialiseCounter
    
End Function


'---------------------------------------------------------------------------------------
' Procedure : GetCpuUsage
' DateTime  : 30/03/2007 18:25
' Author    : Vb System Library
' Purpose   : Renvoie l'utilisation du CPU d'un processus
'               Ne pas oublier d'appeler SetPID avant !
' Params    :
'---------------------------------------------------------------------------------------
Public Function GetCpuUsage() As Single

    Dim ProcTime    As Double
    
    If ProcessID > 0 Then
        GetProcTimes
        QueryPerformanceCounter curEnd
        ProcTime = (ftKernel.dwLowDateTime - ftKernelStart.dwLowDateTime + (ftUser.dwLowDateTime - ftUserStart.dwLowDateTime))
        ProcTime = CDbl(ProcTime / ProcessorCount) / CDbl(((curEnd - curStart) / curFreq))
        QueryPerformanceCounter curStart
        GetCpuUsage = (ProcTime / NanoSec) * 100
        ftKernelStart = ftKernel
        ftUserStart = ftUser
    End If
    
End Function


Private Sub InitialiseCounter()

    Dim SysInfo As SYSTEM_INFO
    
    GetSystemInfo VarPtr(SysInfo)
    ProcessorCount = SysInfo.dwNumberOrfProcessors
    QueryPerformanceFrequency curFreq

    GetProcTimes
    QueryPerformanceCounter curStart

    ftKernelStart = ftKernel
    ftUserStart = ftUser
    
End Sub


Private Sub GetProcTimes()

    Dim hProcess As Long
    Dim T0 As FILETIME
    
    hProcess = OpenProcess(PROCESS_QUERY_INFORMATION, 0&, ProcessID)
    If hProcess Then
        bRet = GetProcessTimes(hProcess, T0, T0, ftKernel, ftUser)
        CloseHandle hProcess
    End If
    
End Sub
