VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWindows"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------------------------------------------------------------------
' Module    : clsWindows
' DateTime  : 30/04/2007 23:23
' Author    : Vb System Library
' Purpose   : Gerer les fenetres
' Copyright : (C) 2007 L'quipe Vb System Library
'              See "modPresentation" for more information
'---------------------------------------------------------------------------------------
' Librairie de fonctions permettant d'agir simplement et rapidement sur le systme.
' Copyright (C) 2007 - L'quipe Vb System Library
' This library is free software; you can redistribute it and/or
' modify it under the terms of the GNU Lesser General Public
' License as published by the Free Software Foundation; either
' version 2.1 of the License, or (at your option) any later version.
' This library is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
' Lesser General Public License for more details.
' You should have received a copy of the GNU Lesser General Public
' License along with this library; if not, write to the Free Software
' Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
'---------------------------------------------------------------------------------------


Option Explicit



'---------------------------------------------------------------------------------------
' Procedure : GetWindow
' DateTime  : 01/05/2007 00:11
' Author    : Vb System Library
' Purpose   : Renvoie un objet Thread
' Params    : hWnd : Handle de la fenetre
'             [Optionnel] RefreshInfos : Si = TRUE rafraichit les informations de la fenetre
'                                           = FALSE par dfaut
'---------------------------------------------------------------------------------------
Public Function GetWindow(ByVal hWnd As Long, Optional ByVal RefreshInfos As Boolean = False) As Window
    Set GetWindow = New Window
    GetWindow.GetWindowByHandle hWnd, RefreshInfos
End Function


'---------------------------------------------------------------------------------------
' Procedure : ListWindows
' DateTime  : 23/11/2006 14:37
' Author    : Vb System Library
' Purpose   : Renvoie la liste des fentres
' Params    : tabHWnd() est un tableau de Long (de 0  UBound) qui sera modifi  la sortie de la fonction.
'               Il contiendra les handles de toutes les fenetres ouvertes
'---------------------------------------------------------------------------------------
Public Sub ListWindows(ByRef tabHWnd() As Long)
    Dim CurrWnd     As Long
    Dim Compteur    As Long
    ' Redimensionne le tableau
    ReDim tabHWnd(0) As Long
    ' On part d'une premire fenetre : le bureau (la premire n'a pas d'importance)
    CurrWnd = GetWindowAPI(GetDesktopWindow(), GW_CHILD)
    Compteur = 0
    ' Tant qu'on a une fenetre
    While CurrWnd <> 0
        ReDim Preserve tabHWnd(Compteur) As Long
        tabHWnd(Compteur) = CurrWnd
        Compteur = Compteur + 1
        ' On prend la fenetre suivante
        CurrWnd = GetWindowAPI(CurrWnd, GW_HWNDNEXT)
    Wend
End Sub


'---------------------------------------------------------------------------------------
' Procedure : GetWindowCaption
' DateTime  : 03/12/2006 15:52
' Author    : Vb System Library
' Purpose   : Renvoie le titre de la fentre
' Params    : hWnd : handle de la fenetre
'---------------------------------------------------------------------------------------
Public Function GetWindowCaption(ByVal hWnd As Long) As String
    Dim Length As Long
    ' On rcupre la longueur de la chaine et on formate une chaine  cette longueur
    Length = GetWindowTextLength(hWnd)
    GetWindowCaption = Space$(Length + 1)
    ' On rcupre le nom de la fenetre
    Length = GetWindowTextA(hWnd, GetWindowCaption, Length + 1)
    GetWindowCaption = Left$(GetWindowCaption, Len(GetWindowCaption) - 1)
End Function


'---------------------------------------------------------------------------------------
' Procedure : SetWindowCaption
' DateTime  : 24/12/2006 16:27
' Author    : Vb System Library
' Purpose   : Modifie le titre de la fenetre
' Params    :   hWnd : handle de la fenetre
'               Caption : Nouveau titre
'---------------------------------------------------------------------------------------
Public Function SetWindowCaption(ByVal hWnd As Long, ByVal Caption As String)
    SetWindowTextA hWnd, Caption
End Function


'---------------------------------------------------------------------------------------
' Procedure : GetWindowPosition
' DateTime  : 23/12/2006 19:35
' Author    : Vb System Library
' Purpose   : Renvoie la position de la fenetre sous forme de type Rect
' Params    : hWnd : Handle de la fenetre
'---------------------------------------------------------------------------------------
Public Function GetWindowPosition(ByVal hWnd As Long) As RECT
    Dim tmpRect As RECT
    GetWindowRect hWnd, tmpRect
    GetWindowPosition = tmpRect
End Function


'---------------------------------------------------------------------------------------
' Procedure : SetWindowPosition
' DateTime  : 23/12/2006 19:35
' Author    : Vb System Library
' Purpose   : Positionne une fenetre
' Params    : hWnd : Handle de la fenetre
'               Left, Top, Width, Height sont optionnels de type Long
'               Si un argument n'est pas prcis, alors sa valeur ne sera pas modifie
'               (ils sont dfinis ici en tant que Variant afin de pouvoir utiliser IsMissing)
'---------------------------------------------------------------------------------------
Public Function SetWindowPosition(ByVal hWnd As Long, Optional ByVal Left As Variant, Optional Top As Variant, Optional Width As Variant, Optional Height As Variant)
    Dim WndPl As WINDOWPLACEMENT
    WndPl.Length = Len(WndPl)
    GetWindowPlacement hWnd, WndPl
    If (Not IsMissing(Left)) And IsNumeric(Left) Then
        WndPl.rcNormalPosition.Right = WndPl.rcNormalPosition.Right - WndPl.rcNormalPosition.Left + Left
        WndPl.rcNormalPosition.Left = Left
    End If
    If (Not IsMissing(Top)) And IsNumeric(Top) Then
        WndPl.rcNormalPosition.Bottom = WndPl.rcNormalPosition.Bottom - WndPl.rcNormalPosition.Top + Top
        WndPl.rcNormalPosition.Top = Top
    End If
    If (Not IsMissing(Width)) And IsNumeric(Width) Then WndPl.rcNormalPosition.Right = WndPl.rcNormalPosition.Left + Width
    If (Not IsMissing(Height)) And IsNumeric(Height) Then WndPl.rcNormalPosition.Bottom = WndPl.rcNormalPosition.Top + Height
    SetWindowPlacement hWnd, WndPl
End Function


'---------------------------------------------------------------------------------------
' Procedure : EnableWindowOpacity
' DateTime  : 03/12/2006 16:01
' Author    : Vb System Library
' Purpose   : Active la transparence d'une fenetre (ncessite Win2k ou +)
'               Renvoie FALSE si la transparence ne peut pas etre applique
' Params    : hWnd : Handle de la fenetre
'---------------------------------------------------------------------------------------
Public Function EnableWindowOpacity(ByVal hWnd As Long) As Boolean
    On Error GoTo Err
    SetWindowLongA hWnd, GWL_EXSTYLE, GetWindowLongA(hWnd, GWL_EXSTYLE) Or WS_EX_LAYERED
    EnableWindowOpacity = True
    Exit Function
Err:
    EnableWindowOpacity = False
End Function
' Change la valeur de la transparence (de 0 : transparent  255 : opaque)
Public Function ChangeWindowOpacity(ByVal hWnd As Long, ByVal Alpha As Byte) As Boolean
    On Error GoTo Err
    SetLayeredWindowAttributes hWnd, 0, Alpha, LWA_ALPHA
    ChangeWindowOpacity = True
    Exit Function
Err:
    ChangeWindowOpacity = False
End Function
' Dsactive la transparence
Public Function DisableWindowOpacity(ByVal hWnd As Long)
    On Error Resume Next
    SetWindowLongA hWnd, GWL_EXSTYLE, GetWindowLongA(hWnd, GWL_EXSTYLE) - WS_EX_LAYERED
End Function


'---------------------------------------------------------------------------------------
' Procedure : WindowVisible
' DateTime  : 31/12/2006 14:50
' Author    : Vb System Library
' Purpose   : Renvoie TRUE si la fenetre est visible, FALSE dans le cas contraire
' Params    : hWnd : Handle de la fenetre
'---------------------------------------------------------------------------------------
Public Function WindowVisible(ByVal hWnd As Long) As Boolean
    WindowVisible = IsWindowVisible(hWnd)
End Function


'---------------------------------------------------------------------------------------
' Procedure : ShowWindow
' DateTime  : 31/12/2006 14:54
' Author    : Vb System Library
' Purpose   : Permet de montrer une fenetre qui n'tait pas visible
' Params    : hWnd : Handle de la fenetre
'---------------------------------------------------------------------------------------
Public Function ShowWindow(ByVal hWnd As Long)
    ShowWindowA hWnd, SW_SHOW
End Function


'---------------------------------------------------------------------------------------
' Procedure : HideWindow
' DateTime  : 31/12/2006 14:54
' Author    : Vb System Library
' Purpose   : Permet de cacher une fenetre qui tait visible
' Params    : hWnd : Handle de la fenetre
'---------------------------------------------------------------------------------------
Public Function HideWindow(ByVal hWnd As Long)
    ShowWindowA hWnd, SW_HIDE
End Function


'---------------------------------------------------------------------------------------
' Procedure : RenameWindow
' DateTime  : 07/02/2007 21:35
' Author    : Vb System Library
' Purpose   : Change le texte d'une fentre
' Params    : hWnd : Handle de la fenetre
'---------------------------------------------------------------------------------------
Public Function RenameWindow(ByVal hWnd As Long, ByVal Caption As String)
    SetWindowTextA hWnd, Caption
End Function


'---------------------------------------------------------------------------------------
' Procedure : WindowEnabled
' DateTime  : 22/02/2007 00:49
' Author    : Vb System Library
' Purpose   : Renvoie TRUE si la fenetre est active
' Params    : hWnd : Handle de la fenetre
'---------------------------------------------------------------------------------------
Public Function WindowEnabled(ByVal hWnd As Long) As Boolean
    WindowEnabled = IsWindowEnabled(hWnd)
End Function


'---------------------------------------------------------------------------------------
' Procedure : EnableWindow
' DateTime  : 07/02/2007 21:35
' Author    : Vb System Library
' Purpose   : Active une fentre
' Params    : hWnd : Handle de la fenetre
'---------------------------------------------------------------------------------------
Public Function SetWindowEnabled(ByVal hWnd As Long)
    EnableWindow hWnd, True
End Function


'---------------------------------------------------------------------------------------
' Procedure : DisableWindow
' DateTime  : 07/02/2007 21:35
' Author    : Vb System Library
' Purpose   : Desactive une fentre
' Params    : hWnd : Handle de la fenetre
'---------------------------------------------------------------------------------------
Public Function SetWindowDisabled(ByVal hWnd As Long)
    EnableWindow hWnd, False
End Function


'---------------------------------------------------------------------------------------
' Procedure : CloseWindow
' DateTime  : 07/02/2007 21:35
' Author    : Vb System Library
' Purpose   : Ferme la fentre
' Params    : hWnd : Handle de la fenetre
'---------------------------------------------------------------------------------------
Public Function CloseWindow(hWnd As Long)
    SendMessage hWnd, WM_CLOSE, 0, 0
End Function


'---------------------------------------------------------------------------------------
' Procedure : EnableCloseButton
' DateTime  : 07/02/2007 21:37
' Author    : Vb System Library
' Purpose   : Permet d'activer la croix "Fermer" du menu systme d'une fentre lorsqu'elle tait grise
' Params    : hWnd : Handle de la fenetre
'---------------------------------------------------------------------------------------
Public Function EnableCloseButton(ByVal hWnd As Long)
    ' on dgrise grce  true qui remet le menu  zro
    GetSystemMenu hWnd, True
    DrawMenuBar hWnd
End Function


'---------------------------------------------------------------------------------------
' Procedure : DisableCloseButton
' DateTime  : 07/02/2007 21:38
' Author    : Vb System Library
' Purpose   : Dsactive la croix fermer
' Params    : hWnd : Handle de la fenetre
'---------------------------------------------------------------------------------------
Public Function DisableCloseButton(ByVal hWnd As Long)
    Dim hMenu As Long
    Dim nCount As Long
    hMenu = GetSystemMenu(hWnd, 0)
    nCount = GetMenuItemCount(hMenu)
    Call RemoveMenu(hMenu, nCount - 1, MF_REMOVE Or MF_BYPOSITION)
    Call RemoveMenu(hMenu, nCount - 2, MF_REMOVE Or MF_BYPOSITION)
    DrawMenuBar hWnd
End Function


'---------------------------------------------------------------------------------------
' Procedure : GetWindowClass
' DateTime  : 25/02/2007 18:54
' Author    : Vb System Library
' Purpose   : Renvoie le nom de la classe de la fentre
' Params    : hWnd : Handle de la fenetre
'---------------------------------------------------------------------------------------
Public Function GetWindowClass(ByVal hWnd As Long) As String
    ' On prpare la chaine de caractre avec 255 espaces
    GetWindowClass = Space$(255)
    ' On rcure le nom de la classe
    GetClassNameA hWnd, GetWindowClass, 255
    ' On efface les caractres vides
    GetWindowClass = Left$(GetWindowClass, InStr(GetWindowClass, vbNullChar) - 1)
End Function


'---------------------------------------------------------------------------------------
' Procedure : IsTask
' DateTime  : 25/02/2007 18:52
' Author    : Vb System Library
' Purpose   : Renvoie TRUE si la fentre est une tche (apparait dans le Ctrl Alt Suppr)
'               Critres :      - Visible
'                               - Avoir un titre
'                               - Pas de parent
'                               - Pas de propritaire
'                               - a ne doit pas etre le TaskManager (Progman)
' Params    : hWnd : Handle de la fenetre
'---------------------------------------------------------------------------------------
Public Function IsTask(ByVal hWnd As Long) As Boolean
    'le fentre doit tre visible
    If IsWindowVisible(hWnd) And (GetWindowLongA(hWnd, GWL_HWNDPARENT) = 0) And Not (GetWindowTextLength(hWnd) = 0) Then
        ' Vrifie que ce n'est pas le TaskManager
        If GetWindowClass(hWnd) <> "Progman" Then
            IsTask = True
        End If
    End If
End Function


'---------------------------------------------------------------------------------------
' Procedure : GetWindowParentProcess
' DateTime  : 01/03/2007 18:48
' Author    : Vb System Library
' Purpose   : Permet de rcuprer l'ID du processus d'une fentre
' Params    : hWnd : Handle de la fenetre
'---------------------------------------------------------------------------------------
Public Function GetWindowParentProcess(ByVal hWnd As Long) As Long
    GetWindowThreadProcessId hWnd, GetWindowParentProcess
End Function


'---------------------------------------------------------------------------------------
' Procedure : GetWindowParentThreadID
' DateTime  : 01/03/2007 18:48
' Author    : Vb System Library
' Purpose   : Permet de rcuprer l'ID du thread qui a cr une fenetre
' Params    : hWnd : Handle de la fenetre
'---------------------------------------------------------------------------------------
Public Function GetWindowParentThreadID(ByVal hWnd As Long) As Long
    GetWindowParentThreadID = GetWindowThreadProcessId(hWnd, 0&)
End Function
