VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Monitor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------------------------------------------------------------------
' Module    : Monitor
' DateTime  : 30/04/2007 23:25
' Author    : Vb System Library
' Purpose   : Objet Ecran
' Copyright : (C) 2007 L'quipe Vb System Library
'              See "modPresentation" for more information
'---------------------------------------------------------------------------------------
' Librairie de fonctions permettant d'agir simplement et rapidement sur le systme.
' Copyright (C) 2007 - L'quipe Vb System Library
' This library is free software; you can redistribute it and/or
' modify it under the terms of the GNU Lesser General Public
' License as published by the Free Software Foundation; either
' version 2.1 of the License, or (at your option) any later version.
' This library is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
' Lesser General Public License for more details.
' You should have received a copy of the GNU Lesser General Public
' License along with this library; if not, write to the Free Software
' Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
'---------------------------------------------------------------------------------------


'---------------------------------------------------------------------------------------
'
' Proprits
'   Handle
'   Name
'   IsMainMonitor
'   Left
'   Top
'   Width
'   Height
'   WorkingAreaLeft
'   WorkingAreaTop
'   WorkingAreaWidth
'   WorkingAreaHeight
'
' Mthodes
'   RefreshInfos
'
'---------------------------------------------------------------------------------------

Option Explicit

Private cScreens As clsScreens

' Les infos sur ce moniteur
Private tabInfos(0 To 6) As Variant

' Les diffrentes infos de l'cran
Private Enum enumMonitorInfo
    emonitorHandle = 0              ' Handle
    emonitorName = 1                ' Nom
    emonitorIsMainMonitor = 2       ' Si c'est le moniteur principal
    emonitorLeft = 3                ' Position gauche
    emonitorTop = 4                 ' Position droite
    emonitorWidth = 5               ' Largeur
    emonitorHeight = 6              ' Hauteur
    emonitorWorkingAreaLeft = 7     ' Position gauche
    emonitorWorkingAreaTop = 8      ' Position droite
    emonitorWorkingAreaWidth = 9    ' Largeur
    emonitorWorkingAreaHeight = 10  ' Hauteur
End Enum



Private Sub Class_Initialize()
    Set cScreens = New clsScreens
End Sub

Private Sub Class_Terminate()
    Set cScreens = Nothing
End Sub


'---------------------------------------------------------------------------------------
' Les mthodes
'---------------------------------------------------------------------------------------


' Retrouve les infos de l'cran grace  son handle
Friend Sub GetMonitorByHandle(ByVal hMonitor As Long)
    tabInfos(emonitorHandle) = hMonitor
    RefreshInfos
End Sub

Public Sub RefreshInfos()
    Dim MonInfos As MonitorInfos
    MonInfos = cScreens.GetMonitorInfos(tabInfos(emonitorHandle))
    With MonInfos
        tabInfos(emonitorName) = .Name
        tabInfos(emonitorIsMainMonitor) = .IsMainMonitor
        tabInfos(emonitorLeft) = .Dimensions.Left
        tabInfos(emonitorTop) = .Dimensions.Top
        tabInfos(emonitorWidth) = .Dimensions.Right - .Dimensions.Left
        tabInfos(emonitorHeight) = .Dimensions.Bottom - .Dimensions.Top
        tabInfos(emonitorWorkingAreaLeft) = .WorkingArea.Left
        tabInfos(emonitorWorkingAreaTop) = .WorkingArea.Top
        tabInfos(emonitorWorkingAreaWidth) = .WorkingArea.Right - .WorkingArea.Left
        tabInfos(emonitorWorkingAreaHeight) = .WorkingArea.Bottom - .WorkingArea.Top
    End With
End Sub


'---------------------------------------------------------------------------------------
' Les proprits
'---------------------------------------------------------------------------------------

Public Property Get Handle() As Long
    Handle = tabInfos(emonitorHandle)
End Property

Public Property Get Name() As String
    Name = tabInfos(emonitorName)
End Property

Public Property Get IsMainMonitor() As Boolean
    IsMainMonitor = tabInfos(emonitorIsMainMonitor)
End Property

Public Property Get Left() As Long
    Left = tabInfos(emonitorLeft)
End Property
Public Property Get Top() As Long
    Top = tabInfos(emonitorTop)
End Property
Public Property Get Width() As Long
    Width = tabInfos(emonitorWidth)
End Property
Public Property Get Height() As Long
    Height = tabInfos(emonitorHeight)
End Property

Public Property Get WorkingAreaLeft() As Long
    WorkingAreaLeft = tabInfos(emonitorWorkingAreaLeft)
End Property
Public Property Get WorkingAreaTop() As Long
    WorkingAreaTop = tabInfos(emonitorWorkingAreaTop)
End Property
Public Property Get WorkingAreaWidth() As Long
    WorkingAreaWidth = tabInfos(emonitorWorkingAreaWidth)
End Property
Public Property Get WorkingAreaHeight() As Long
    WorkingAreaHeight = tabInfos(emonitorWorkingAreaHeight)
End Property

