VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Thread"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------------------------------------------------------------------
' Module    : Thread
' DateTime  : 30/04/2007 23:26
' Author    : Vb System Library
' Purpose   : Objet Thread
' Copyright : (C) 2007 L'quipe Vb System Library
'              See "modPresentation" for more information
'---------------------------------------------------------------------------------------
' Librairie de fonctions permettant d'agir simplement et rapidement sur le systme.
' Copyright (C) 2007 - L'quipe Vb System Library
' This library is free software; you can redistribute it and/or
' modify it under the terms of the GNU Lesser General Public
' License as published by the Free Software Foundation; either
' version 2.1 of the License, or (at your option) any later version.
' This library is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
' Lesser General Public License for more details.
' You should have received a copy of the GNU Lesser General Public
' License along with this library; if not, write to the Free Software
' Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
'---------------------------------------------------------------------------------------


'---------------------------------------------------------------------------------------
'
' Proprits
'       [statiques]
'   ID
'       [dynamiques]
'
' Mthodes
'   RefreshInfos
'   SuspendThread
'   ResumeThread
'
'---------------------------------------------------------------------------------------

Option Explicit

Private clsThread As New clsThreads

' Les infos sur ce thread
Private tabInfos(0 To 1) As Variant

' Les diffrentes infos du thread
Private Enum enumThreadInfo
    ethreadID = 0                                  ' L'id
End Enum



'---------------------------------------------------------------------------------------
' Les mthodes
'---------------------------------------------------------------------------------------


' Retrouve les infos statiques du thread  partir de son ID
' [Optionnel] RefreshInfos : Active ou non le rafraichissement des infos dynamiques du thread
Friend Sub GetThreadByID(ByVal ThreadID As Long, Optional ByVal bRefreshInfos As Boolean = False)
    tabInfos(ethreadID) = ThreadID
    ' Les informations statiques
    ' Les informations dynamiques
    If bRefreshInfos = True Then RefreshInfos
End Sub


' Rafraichit les informations dynamiques
Public Sub RefreshInfos()
    Dim ThreadID As Long
    ThreadID = tabInfos(ethreadID)
End Sub


' Suspend l'execution du thread
Public Sub SuspendThread()
    clsThread.SuspendThread tabInfos(ethreadID)
End Sub


' Reprend l'execution d'un thread stopp
' (Note : Resume est un mot cl rserv)
Public Sub ResumeThread()
    clsThread.ResumeThread tabInfos(ethreadID)
End Sub


'---------------------------------------------------------------------------------------
' Les proprits
'---------------------------------------------------------------------------------------

Public Property Get ID() As Long
    ID = tabInfos(ethreadID)
End Property
