VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Threads"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------------------------------------------------------------------
' Module    : Threads
' DateTime  : 30/04/2007 23:26
' Author    : Vb System Library
' Purpose   : Collection de Threads
' Copyright : (C) 2007 L'quipe Vb System Library
'              See "modPresentation" for more information
'---------------------------------------------------------------------------------------
' Librairie de fonctions permettant d'agir simplement et rapidement sur le systme.
' Copyright (C) 2007 - L'quipe Vb System Library
' This library is free software; you can redistribute it and/or
' modify it under the terms of the GNU Lesser General Public
' License as published by the Free Software Foundation; either
' version 2.1 of the License, or (at your option) any later version.
' This library is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
' Lesser General Public License for more details.
' You should have received a copy of the GNU Lesser General Public
' License along with this library; if not, write to the Free Software
' Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
'---------------------------------------------------------------------------------------


'---------------------------------------------------------------------------------------
'
' Proprits
'   Thread
'   Count
'
' Mthodes
'   RefreshList
'   RefreshItemInfos
'
'---------------------------------------------------------------------------------------

Option Explicit


' Les Processus (de 1  nbProcess)
Private colThreads()    As Thread
Private nbThreads       As Long

Private clsThread       As clsThreads


Private Sub Class_Initialize()
    Set clsThread = New clsThreads
    ReDim colThreads(1 To 1) As Thread
    nbThreads = 0
End Sub

Private Sub Class_Terminate()
    Dim t As Long
    ' Vide le tableau de threads
    For t = 1 To nbThreads
        Set colThreads(t) = Nothing
    Next t
    Erase colThreads
    Set clsThread = Nothing
End Sub


'---------------------------------------------------------------------------------------
' Les proprits
'---------------------------------------------------------------------------------------


' Renvoie un item de la liste
Public Property Get Thread(ByVal Index As Long) As Thread
    Set Thread = colThreads(Index)
End Property


' Le nombre de processus
Public Property Get Count() As Long
    Count = nbThreads
End Property


'---------------------------------------------------------------------------------------
' Procedure : RefreshItemInfos
' DateTime  : 09/03/2007 22:36
' Author    : Vb System Library
' Purpose   : Rafraichit toutes les informations d'un item de la liste
' Params    :
'---------------------------------------------------------------------------------------
Public Sub RefreshItemInfos()
    Dim t As Long
    For t = 1 To nbThreads
        colThreads(t).RefreshInfos
    Next
End Sub


'---------------------------------------------------------------------------------------
' Procedure : RefreshList
' DateTime  : 30/11/2006 17:19
' Author    : Vb System Library
' Purpose   : Rafraichit la liste des processus
' Params    :   [Optionnel] RefreshItemInfos : Si activ, les informations des processus seront rafraichies
'                                               Sinon elles ne seront PAS rafraichies (PAR DEFAUT)
'               Les parametres suivants dfinissent le filtre de la liste :
'               [Optionnel] ID : ID du thread
'---------------------------------------------------------------------------------------
Public Sub RefreshList(Optional ByVal RefreshItemInfos As Boolean = False, Optional ByVal ID As Long = -1)

    Dim tabThreadID()       As Long
    Dim tempThread          As Thread
    Dim t                   As Long
    Dim Valide              As Boolean
    Dim Count               As Long

    ' Vide la liste
    For t = 1 To nbThreads
        Set colThreads(t) = Nothing
    Next t
    nbThreads = 0
    Erase colThreads

    ' Dresse la liste des threads
    clsThread.ListThreads tabThreadID()
    Count = 0
    
    For t = LBound(tabThreadID) To UBound(tabThreadID)
        ' Cre l'objet processus
        Set tempThread = New Thread
        tempThread.GetThreadByID tabThreadID(t), RefreshItemInfos
        ' Si le processus rpond aux critres
        Valide = True
        If (ID <> -1) And (tempThread.ID <> ID) Then Valide = False
        ' Ajoute le processus
        If Valide = True Then
            ' Redimensionne
            Count = Count + 1
            ReDim Preserve colThreads(1 To Count) As Thread
            Set colThreads(Count) = tempThread
        End If
        Set tempThread = Nothing
    Next t
    
    ' Le nombre d'lments du tableau
    nbThreads = Count

    Erase tabThreadID
End Sub


