VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Windows"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------------------------------------------------------------------
' Module    : Windows
' DateTime  : 30/04/2007 23:27
' Author    : Vb System Library
' Purpose   : Collection de fenetres
' Copyright : (C) 2007 L'quipe Vb System Library
'              See "modPresentation" for more information
'---------------------------------------------------------------------------------------
' Librairie de fonctions permettant d'agir simplement et rapidement sur le systme.
' Copyright (C) 2007 - L'quipe Vb System Library
' This library is free software; you can redistribute it and/or
' modify it under the terms of the GNU Lesser General Public
' License as published by the Free Software Foundation; either
' version 2.1 of the License, or (at your option) any later version.
' This library is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
' Lesser General Public License for more details.
' You should have received a copy of the GNU Lesser General Public
' License along with this library; if not, write to the Free Software
' Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
'---------------------------------------------------------------------------------------


'---------------------------------------------------------------------------------------
'
' Proprits
'   Window
'   Count
'
' Mthodes
'   RefreshList
'   RefreshItemInfos
'
'---------------------------------------------------------------------------------------

Option Explicit


' Les fenetres (de 1  nbWindows)
Private colWindows()    As Window
Private nbWindows       As Long

Private clsWindow       As clsWindows


Private Sub Class_Initialize()
    Set clsWindow = New clsWindows
    ReDim colWindows(1 To 1) As Window
    nbWindows = 0
End Sub

Private Sub Class_Terminate()
    Dim t As Long
    ' Vide le tableau de windows
    For t = 1 To nbWindows
        Set colWindows(t) = Nothing
    Next t
    Erase colWindows
    Set clsWindow = Nothing
End Sub


'---------------------------------------------------------------------------------------
' Les proprits
'---------------------------------------------------------------------------------------


' Renvoie un item de la liste
Public Property Get Window(ByVal Index As Long) As Window
    Set Window = colWindows(Index)
End Property


' Le nombre de processus
Public Property Get Count() As Long
    Count = nbWindows
End Property


'---------------------------------------------------------------------------------------
' Procedure : RefreshItemInfos
' DateTime  : 09/03/2007 22:36
' Author    : Vb System Library
' Purpose   : Rafraichit toutes les informations d'un item de la liste
' Params    :
'---------------------------------------------------------------------------------------
Public Sub RefreshItemInfos()
    Dim t As Long
    For t = 1 To nbWindows
        colWindows(t).RefreshInfos
    Next
End Sub


'---------------------------------------------------------------------------------------
' Procedure : RefreshList
' DateTime  : 14/12/2006 18:15
' Author    : Vb System Library
' Purpose   : Rafraichit la liste des fenetres (rafraichit les proprits des fenetres aussi)
' Params    :
'               Les parametres suivants dfinissent le filtre de la liste :
'               [Optionnel] Handle : Handle de la fenetre
'               [Optionnel] Caption : Titre de la fenetre
'               [Optionnel] ParentProcessID : ID du processus parent
'---------------------------------------------------------------------------------------
Public Sub RefreshList(Optional ByVal Handle As Long = -1, Optional ByVal Caption As Variant, Optional ByVal ParentProcessID As Long = -1)
    
    Dim tabHWnd()           As Long
    Dim tempWindow          As Window
    Dim t                   As Long
    Dim Valide              As Boolean
    Dim Count               As Long

    ' Vide la liste
    For t = 1 To nbWindows
        Set colWindows(t) = Nothing
    Next t
    nbWindows = 0
    Erase colWindows

    ' Dresse la liste des fenetres
    clsWindow.ListWindows tabHWnd()
    Count = 0

    For t = LBound(tabHWnd) To UBound(tabHWnd)
        ' Cre l'objet fenetre
        Set tempWindow = New Window
        tempWindow.GetWindowByHandle tabHWnd(t), True   ' Rafraichit toutes les infos
        ' Si la fenetre rpond aux critres
        Valide = True
        If (Handle <> -1) And (tempWindow.Handle <> Handle) Then Valide = False
        If (Not IsMissing(Caption)) Then
            If (VarType(Caption) = vbString) And (tempWindow.Caption <> Caption) Then Valide = False
        End If
        If (ParentProcessID <> -1) And (tempWindow.ParentProcessID <> ParentProcessID) Then Valide = False
        ' Ajoute la fenetre
        If Valide = True Then
            ' Redimensionne
            Count = Count + 1
            ReDim Preserve colWindows(1 To Count) As Window
            Set colWindows(Count) = tempWindow
        End If
        Set tempWindow = Nothing
    Next t
    
    ' Le nombre d'lments du tableau
    nbWindows = Count

    Erase tabHWnd

End Sub



